;============================================================
; Thwimp-Style Thwomp
; By Erik
;
; Description: A Thwomp that will do its jumps similar to a
; Thwimp.
;============================================================

!speed_right    = $10
!speed_left     = -!speed_right
!angry_face     = $CA

thwomp_tiles:
        db $8E,$8E,$AE,$AE
thwomp_props:
        db $01,$41,$01,$41,$01

;---
print "MAIN ",pc
        PHB
        PHK
        PLB
        JSR thwimpy_thwomp
        PLB
print "INIT ",pc      
        RTL

;---

thwimpy_thwomp:
        JSR draw_sprite
        LDA !14C8,x
        EOR #$08
        ORA $9D
        BNE return
        %SubOffScreen()
        JSL $01A7DC|!BankB
        JSL $019138|!BankB
        JSL $01801A|!BankB
        JSL $018022|!BankB
        LDA !AA,x  
        BMI .rising
        CMP #$40      
        BCS .peak_speed 
        ADC #$05 
.rising
        CLC           
        ADC #$03      
        BRA .store
.peak_speed
        LDA #$40   
.store
        STA !AA,x  
        LDA !1588,x 
        AND #$08
        BEQ +
        LDA #$10
        STA !AA,x
+       LDA !1588,x 
        AND #$04 
        BEQ return 
        LDA !1588,x 
        BMI .slope
        LDA #$00    
        LDY !15B8,x 
        BEQ +
.slope
        LDA #$18
+       STA !AA,x   
        STZ !B6,x  
        STZ !AA,x 
        LDA !1540,x
        BEQ hit_ground
        DEC 
        BNE return
        LDA #$A0   
        STA !AA,x
        INC !C2,x
        LDA !C2,x  
        LSR
        LDA #!speed_right
        BCC +
        LDA #!speed_left
+       STA !B6,x
return:
        RTS

hit_ground:
        LDA #$01
        STA $1DF9|!Base2
        LDA #$40
        STA !1540,x
        RTS

;---

thwomp_x_disp:
        db $FC,$04,$FC,$04,$00
thwomp_y_disp:
        db $00,$00,$10,$10,$08

draw_sprite:
        %GetDrawInfo()
        LDA !15F6,x
        STA $03
        STZ $02
        LDA !1588,x
        AND #$04
        BNE +
        STA $02

+       LDX #$03
        CMP #$00
        BNE .loop
        INX
.loop
        LDA $00
        CLC
        ADC thwomp_x_disp,x
        STA $0300|!Base2,y
        LDA $01
        CLC 
        ADC thwomp_y_disp,x
        STA $0301|!Base2,y
        LDA thwomp_props,x
        ORA $64
        ORA $03
        STA $0303|!Base2,y
        
        LDA thwomp_tiles,x
        CPX #$04
        BNE .no_face
        LDA #!angry_face
.no_face
        STA $0302|!Base2,y
        INY #4
        DEX
        BPL .loop

        LDX $15E9|!Base2
        LDY #$02
        LDA #$04
        JSL $01B7B3|!BankB
        RTS

